<?PHP
/*
 * DIREITOS AUTORAIS RESERVADOS (C) 2007 UFRJ
 * 
 * ESTE PROGRAMA É SOFTWARE LIVRE; VOCÊ PODE REDISTRIBUÍ-LO E/OU MODIFICÁ-LO SOB OS
 * TERMOS DA LICENÇA PÚBLICA GERAL GNU CONFORME PUBLICADA PELA FREE SOFTWARE FOUNDATION;
 * TANTO A VERSÃO 2 DA LICENÇA, COMO (A SEU CRITÉRIO) QUALQUER VERSÃO POSTERIOR.

 * ESTE PROGRAMA É DISTRIBUÍDO NA EXPECTATIVA DE QUE SEJA ÚTIL, PORÉM, SEM NENHUMA GARANTIA;
 * NEM MESMO A GARANTIA IMPLÍCITA DE COMERCIABILIDADE OU ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA.
 * CONSULTE A LICENÇA PÚBLICA GERAL DO GNU PARA MAIS DETALHES.
 * 
 * VOCÊ DEVE TER RECEBIDO UMA CÓPIA DA LICENÇA PÚBLICA GERAL DO GNU JUNTO COM ESTE PROGRAMA; 
 * SE NÃO, ACESSE <<HTTP://WWW.GNU.ORG/LICENSES/LICENSES.PT-BR.HTML>>
 */

<?

require_once 'util.php';

function pis_valido($codigo)/*{{{*/
{
	if(strlen($codigo) != 11 || !ctype_digit($codigo))
		return false;

	// Eh mais rápido testar se o codigo eh composto de
	// digitos iguais assim...
	$igual = true;
	for($j=1; $j<11; ++$j)
	{
		if($codigo[$j] != $codigo[$j-1])
		{
			$igual = false;
			break;
		}
	}
	if($igual)
		return false;

	$pesos = '3298765432';

	$soma = 0;
	for($i=0; $i<10; ++$i)
		$soma += $codigo[$i] * $pesos[$i];

	$dv = $soma % 11;
	if($dv != 0)
		$dv = 11-$dv;

	return $dv == $codigo[10];
}/*}}}*/

class PIS extends Documento
{
	function setTableDefinition()
	{
		$this->setTableName('saude.pis');

		$this->hasColumn('numero','string', 11, 
			array('fixed','notnull','notblank','unique'));

		$this->hasColumn('idpessoa', 'integer', NULL, array('notnull'));

		Documento::setTableDefinition();
	}

	function validate()
	{
		Documento::validate();

		trim_string_columns($this);

		$erros = array();

		if(!$this->numero)
			$erros[] = 'O numero do SUS deve ser informado';
		else if(!pis_valido($this->numero))
			$erros[] = 'Número PIS inválido';

		if($erros)
			throw new Exception(implode("\n",$erros));
	}

	function setUp()
	{
		Documento::setUp();

		$this->index('unique_pessoa_pis',
			array('fields'=>array('idpessoa'),
			      'type'=>'unique'));

		$this->hasOne('Pessoa as pessoa',
			array('local'=>'idpessoa',
			      'foreign'=>'id'));
	}
};

?>
